package com.jz.dm.mall.moduls.controller.customer;

import com.jz.common.utils.Result;
import com.jz.common.utils.StatusCode;
import com.jz.common.utils.UserContextUtil;
import com.jz.dm.mall.moduls.entity.MallCustomer;
import com.jz.dm.mall.moduls.service.MallCustomerService;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.http.HttpRequest;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

/**
 * @ClassName:
 * @Author: Carl
 * @Date: 2020/12/2
 * @Version:
 */
@RestController
@RequestMapping("/customer")
@Api(tags = "商城登陆api")
public class LoginController {
    /**
     * 服务对象
     */
    @Autowired
    private MallCustomerService mallCustomerService;

    @Autowired
    private RedisTemplate redisTemplate;
    /**
     * 登录功能
     * @param username 账号
     * @param password 密码
     * @return
     */
    @PostMapping(value = "/login")
    public Result<MallCustomer> login(String username, String password, HttpServletRequest request) {
        // 手机
        String ph = "^[1][34578]\\d{9}$";
        HttpSession session = request.getSession();
        // 如果是手机验证
        if (username.matches(username)) {
            MallCustomer mallCustomer = mallCustomerService.selectByPhone(username);
            if (mallCustomer != null) {
                if (mallCustomer.getCustomerPhone().equals(username) && mallCustomer.getPassword().equals(password)){
                    session.setAttribute("customer_id", mallCustomer.getCustomerId());
                    session.setAttribute("customer_account", mallCustomer.getCustomerAccount());
                    return new Result<>(true, "登录成功！", StatusCode.OK);
                }
                return new Result<>(false, "用户名或密码错误！", StatusCode.ERROR);
            }
        }
        MallCustomer mallCustomer = mallCustomerService.selectByAccount(username);
        if (mallCustomer != null) {
            if (mallCustomer.getCustomerAccount().equals(username) && mallCustomer.getPassword().equals(password)){
                session.setAttribute("customer_id", mallCustomer.getCustomerId());
                session.setAttribute("customer_account", mallCustomer.getCustomerAccount());
                return new Result<>(true, "登录成功！", StatusCode.OK);
            }
        }

        return new Result<>(false, "用户名或密码错误！", StatusCode.ERROR);
    }

}
